﻿Module En_tcpip

    Public MacAddress As String    'ＭＡＣアドレス
    Public NowIpAddress As String  '現在のＩＰアドレス
    Public NowPortNo As Long    '現在のポート番号
    Public Delim As String      'デリミタコード

    Dim ephost As System.Net.IPEndPoint '
    Dim sock As System.Net.Sockets.Socket '
    Dim enc As System.Text.Encoding = System.Text.Encoding.GetEncoding("utf-8")

    Private Function En_Calc_IPA() As Long
        Dim Ipa(4) As Long
        Dim nn As Integer
        Dim ss As String
        Dim mm As Integer

        ss = NowIpAddress
        For mm = 1 To 4
            nn = InStr(ss, ".")
            If nn < 2 And mm < 4 Then 'エラー
                En_Calc_IPA = -1
                Exit Function
            End If
            If mm = 4 Then
                Ipa(mm) = Mid(ss, 1)
            Else
                Ipa(mm) = Mid(ss, 1, nn - 1)
                ss = Mid(ss, nn + 1)
            End If
        Next

        En_Calc_IPA = 0
        For mm = 4 To 1 Step -1
            En_Calc_IPA = Ipa(mm) + (En_Calc_IPA * 256)
        Next
        Return En_Calc_IPA
    End Function

    Private Function En_Tcpip_Connect() As Long '接続する
        Dim IPA As Long
        Dim ret As Long
        Dim eMsg As String

        IPA = En_Calc_IPA()
        ephost = New System.Net.IPEndPoint(IPA, NowPortNo) '(hostadd, 80)

        'Socketの作成
        sock = New System.Net.Sockets.Socket(System.Net.Sockets.AddressFamily.InterNetwork, System.Net.Sockets.SocketType.Stream, System.Net.Sockets.ProtocolType.Tcp)

        '接続
        On Error GoTo Cerr
        sock.Connect(ephost)
        On Error GoTo -1
        Return 0
Cerr:
        eMsg = "Error # " & Str(Err.Number) & " was generated by " & Err.Source & ControlChars.CrLf & Err.Description
        MsgBox(eMsg, MsgBoxStyle.Information, "Error")

        Return -1
    End Function

    Private Function En_Tcpip_Disconnect() As Long
        '閉じる
        sock.Shutdown(System.Net.Sockets.SocketShutdown.Both)
        sock.Close()

        Return 0
    End Function

    Private Function En_Tcpip_Send(ByVal SendDT As String) As Long
        Dim reqBytes As Byte() = enc.GetBytes(SendDT)

        'リクエストメッセージを送信
        sock.Send(reqBytes, reqBytes.Length, System.Net.Sockets.SocketFlags.None)

        Return 0
    End Function

    Private Function En_Tcpip_Rec(ByRef RecDT As String) As Long
        '受信する
        Dim DD As Byte
        Dim resBytes(1023) As Byte
        Dim mem As New System.IO.MemoryStream
        Dim eMsg As String

        sock.ReceiveTimeout = 1000
        While True
            On Error GoTo Rerr
            Dim resSize As Integer = sock.Receive(resBytes, resBytes.Length, System.Net.Sockets.SocketFlags.None)
            If resSize = 0 Then
                Exit While
            End If
            mem.Write(resBytes, 0, resSize)
            'デリミタまで受信したか、調べる
            For MM = 0 To resSize - 1
                DD = resBytes(MM)
                If DD = &HA Then
                    Exit While
                End If
                If DD = &HD Then
                    Exit While
                End If
                If DD = &H4 Then
                    Exit While
                End If
            Next
        End While
        Dim resMsg As String = enc.GetString(mem.GetBuffer(), 0, CInt(mem.Length))
        mem.Close()
        RecDT = resMsg
        Return 0
Rerr:
        emsg = "Error # " & Str(Err.Number) & " was generated by " & Err.Source & ControlChars.CrLf & Err.Description
        MsgBox(eMsg, MsgBoxStyle.Information, "Error")
        Call DispStr(Form1.TextBox4, " 失敗" & vbCrLf)

        Return -1
    End Function

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Public Function En_Set_IpAddress(ByVal No As String) As Long

        NowIpAddress = No '現在のＩＰアドレス

        Return 0
    End Function

    Public Function En_Set_PortNo(ByVal No As Long) As Long

        NowPortNo = No '現在のポート番号

        Return 0
    End Function

    Public Function En_SendStr(ByVal SDT As String, ByVal dlm As String) As Long
        Dim ret As Long

        Call DispStr(Form1.TextBox4, vbCrLf & "接続する・・・・")
        ret = En_Tcpip_Connect() '接続要求
        If ret < 0 Then
            Call DispStr(Form1.TextBox4, " 接続失敗" & vbCrLf)
            Return ret
        End If
        Call DispStr(Form1.TextBox4, " 接続成功！" & vbCrLf)

        Call DispStr(Form1.TextBox4, "　設定コマンド[" & SDT & "]" & vbCrLf)
        Call DispStr(Form1.TextBox4, "　設定する・・・・")
        ret = En_Tcpip_Send(SDT & dlm)
        If ret < 0 Then
            Call DispStr(Form1.TextBox4, " 失敗" & vbCrLf)
        Else
            Call DispStr(Form1.TextBox4, " 成功" & vbCrLf)
        End If

        Call DispStr(Form1.TextBox4, " 接断する" & vbCrLf)
        En_Tcpip_Disconnect() '接断要求
        Return ret
    End Function

    Private Function En_DelimCheck(ByVal rdt As String) As String
        Dim NN As Integer
        Dim MM As Integer
        Dim resMsg As String = ""
        Dim ST1 As String
        Dim ST2 As String

        For MM = 0 To &H1F
            NN = InStr(rdt, Chr(MM))
            If NN <> 0 Then
                ST1 = Mid(rdt, 1, NN - 1)
                If Len(rdt) = NN Then
                    ST2 = ""
                Else
                    ST2 = Mid(rdt, NN + 1)
                End If
                resMsg = ST1 & "<" & Hex(MM) & ">" & ST2
            End If
        Next
        En_DelimCheck = resMsg
    End Function

    Public Function En_SendRecStr(ByVal SDT As String, ByRef RDT As String, ByVal dlm As String) As Long
        Dim ret As Long
        Dim resMsg As String

        Call DispStr(Form1.TextBox4, vbCrLf & "接続する・・・・")
        ret = En_Tcpip_Connect()    '接続要求
        If ret < 0 Then             '接続失敗
            Call DispStr(Form1.TextBox4, " 接続失敗" & vbCrLf)
            Return ret
        End If
        Call DispStr(Form1.TextBox4, " 接続成功！" & vbCrLf)

        Call DispStr(Form1.TextBox4, "　問合コマンド[" & SDT & "]" & vbCrLf)
        Call DispStr(Form1.TextBox4, "　問い合わせる・・・・")
        ret = En_Tcpip_Send(SDT & dlm)
        If ret < 0 Then             '送信に失敗
            Call DispStr(Form1.TextBox4, " 失敗->接断する" & vbCrLf)
            En_Tcpip_Disconnect()   '接断要求
            Return ret
        End If
        Call DispStr(Form1.TextBox4, " 成功！" & vbCrLf)
        Call DispStr(Form1.TextBox4, "　応答を得る・・・・")
        '問合せコマンドなので応答を得る
        ret = En_Tcpip_Rec(SDT)
        resMsg = SDT
        If ret < 0 Then             '受信に失敗
            Call DispStr(Form1.TextBox4, " 失敗->接断する" & vbCrLf)
            En_Tcpip_Disconnect()   '接断要求
            Return ret
        End If
        Call DispStr(Form1.TextBox4, " 成功！" & vbCrLf)
        RDT = resMsg
        resMsg = En_DelimCheck(resMsg)
        Call DispStr(Form1.TextBox4, "　応答[" & resMsg & "]" & vbCrLf)
        Call DispStr(Form1.TextBox4, " 接断する" & vbCrLf)
        ret = En_Tcpip_Disconnect() '接断要求
        If ret < 0 Then
            Return ret
        End If
        Return 0
    End Function
End Module
